<?php
// +----------------------------------------------------------------------
// | 阿里云OSS - STS 临时访问权限令牌获取
// +----------------------------------------------------------------------
// | Copyright (c) 2020 https://www.baidu.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: Rockgyx <815984073@qq.com>
// +----------------------------------------------------------------------

class OssSTS {
    /**
     * ARN角色密钥
    */
    private static $arn= "";
    /**
     * 设置URL的有效期为3600秒
    */
    private static $timeout = 900;
    /**
     * AccessKeyId
    */
    private static $AccessKeyId = '';
    /**
     * AccessKeySecret
    */
    private static $AccessKeySecret = '';
    /**
     * STS临时身份权限获取
    */
    private static $api = 'https://sts.aliyuncs.com?';

    /**
     * 调用入口
     * @todo 无
     * @author 小黄牛
     * @version v1.2.16 + 2020.10.27
     * @deprecated 暂不启用
     * @global 无
     * @return void
    */
    public static function run() {
        date_default_timezone_set("UTC");

        $data = array(
            'Action' => 'AssumeRole',
            'RoleArn' => self::$arn,
            'RoleSessionName' => 'order_sound_recording',
            'DurationSeconds' => self::$timeout,
            'Format' => 'JSON',
            'Version' => '2015-04-01',
            'SignatureMethod' => 'HMAC-SHA1',
            'SignatureVersion' => '1.0',
            'SignatureNonce' => time().rand(100,999),
            'Timestamp' => date('Y-m-d\TH:i:s\Z', time() - date('Z')),
            'AccessKeyId' => self::$AccessKeyId,
        );
        $data['Signature'] = self::sign($data, self::$AccessKeySecret);

        $url = self::$api;
        foreach ($data as $key=>$val) {
            $url .= $key.'='.$val.'&';
        }

        $res = self::https_curl(rtrim($url, '&'));
        return json_decode($res, true);
    }

    /**
     * 生成签名
     * @todo 无
     * @author 小黄牛
     * @version v1.2.16 + 2020.10.27
     * @deprecated 暂不启用
     * @global 无
     * @return void
    */
    private static function sign($params, $accessSecret, $method = "GET") {
        ksort($params);
        $stringToSign = strtoupper($method) . '&' . self::percentEncode('/') . '&';
        $tmp = "";
        foreach ($params as $key => $val) {
            $tmp .= '&' . self::percentEncode($key) . '=' . self::percentEncode($val);
        }
        $tmp = trim($tmp, '&');
        $stringToSign = $stringToSign . self::percentEncode($tmp);
        $key = $accessSecret . '&';
        $hmac = hash_hmac("sha1", $stringToSign, $key, true);
        return base64_encode($hmac);
    }
    
    /**
     * 特殊字符替换
     * @todo 无
     * @author 小黄牛
     * @version v1.2.16 + 2020.10.27
     * @deprecated 暂不启用
     * @global 无
     * @return void
    */
    private static function percentEncode($value = null) {
        $en = urlencode($value);
        $en = str_replace("+", "%20", $en);
        $en = str_replace("*", "%2A", $en);
        $en = str_replace("%7E", "~", $en);
        return $en;
    }

    /**
     * curl
     * @todo 无
     * @version v1.0.0.4 + 2020.06.23
     * @global 无
     * @param string $url 请求地址
     * @param mixed $data 请求参数，默认为空
     * @param array $headers 请求头，默认为空
     * @return mixed 请求返回内容
     */
    protected static function https_curl($url, $data = null, $headers=array())
    {
        $curl = curl_init();

        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);

        if (!empty($data)) {
            curl_setopt($curl, CURLOPT_POST, 1);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
        }
        if (!empty($headers)) {
            curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        }

        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        $response = curl_exec($curl);
        curl_close($curl);
        return $response;
    }

}

